﻿#include <lvgl.h>
#include <TFT_eSPI.h>
//#include <ESP32_FTPClient.h>/* https://github.com/ldab/ESP32_FTPClient */
//#include <WiFi.h>
//#include <WiFiClient.h>
//#include <SimpleFTPServer.h>/* https://github.com/xreef/SimpleFTPServer */
//#include "ESPAsyncWebServer.h"/* https://github.com/khoih-prog/ESPAsync_WiFiManager */
//#include "SPIFFS.h"
//#include "FS.h"
TFT_eSPI tft = TFT_eSPI(); /* TFT instance */
const int screenWidth = 480;
const int  screenHeight = 320;
static lv_color_t buf[screenWidth * screenHeight / 10];
/* ==== EdgeLine Variables ==== */
lv_obj_t * Screen1;
lv_obj_t * Sfondo1;
lv_obj_t * LabelWIFI;
lv_obj_t * LabelPREF;
lv_obj_t * LabelToast;
lv_obj_t * RollerSSID;
lv_obj_t * LabelSSID;
lv_obj_t * LabelPASSW;
lv_obj_t * ListPref;
lv_obj_t * ImgButton1;
/* ---- END of EdgeLine Variables ---- */
/* HANDLERS START      HANDLERS START      HANDLERS START  */
/* ======     Display flushing      Display flushing    ========*/
void my_disp_flush(lv_disp_drv_t *disp, const lv_area_t *area, lv_color_t *color_p) {
  uint16_t c;
  tft.startWrite(); /* Start new TFT transaction */
  tft.setAddrWindow(area->x1, area->y1, (area->x2 - area->x1 + 1), (area->y2 - area->y1 + 1)); /* set the working window */
  for (int y = area->y1; y <= area->y2; y++) {
    for (int x = area->x1; x <= area->x2; x++) {
      c = color_p->full; tft.writeColor(c, 1); color_p++;
    }
  }
  tft.endWrite(); /* terminate TFT transaction */
  lv_disp_flush_ready(disp); /* tell lvgl that flushing is done */
}
/* ===========   READ TOUCHPAD ============ */
bool my_input_read(lv_indev_drv_t * indev_driver, lv_indev_data_t * data) {
  uint16_t touchX, touchY;
  bool touched = tft.getTouch(&touchX, &touchY, 600);
  if (!touched) {
    return false;
  }
  if (touchX > screenWidth || touchY > screenHeight) {
  } else {
    data->state = touched ? LV_INDEV_STATE_PR : LV_INDEV_STATE_REL;
    data->point.x = touchX;
    data->point.y = touchY;
    TouchTimer = millis();
  }
  return false; /*Return `false` because we are not buffering and no more data to read*/
}

/* ==== EdgeLine Handlers ==== */
static void RollerSSID_eventhandler(lv_obj_t * obj, lv_event_t event)
{
    if(event == LV_EVENT_CLICKED) {
        SSIDselected(obj, event);
    }
}
static void ListPref_eventhandler(lv_obj_t * obj, lv_event_t event)
{
    if(event == LV_EVENT_CLICKED) {
        RichiamoTastiera(obj, event);
    }
}
static void ImgButton1_eventhandler(lv_obj_t * obj, lv_event_t event)
{
}
/* ---- END of EdgeLine Handlers ---- */
/* ======    SETUP     SETUP      SETUP       SETUP  ===== */
void setup() {
Serial.begin(115200); /* prepare for possible serial debug */
  delay(100);
//  if (SPIFFS.begin()) {
//    Serial.println(F("SPIFFS mounted correctly."));
//  } else {
//    Serial.println(F("!An error occurred during SPIFFS mounting"));
//  }
  lv_init();
  tft.begin(); /* TFT init */
  tft.setRotation(3);
  uint16_t calData[5] = { 275, 3620, 264, 3532, 1 };
  tft.setTouch(calData);
  lv_disp_buf_init(&disp_buf, buf, NULL, screenWidth * screenHeight / 10);
  /* ==== Initialize the DISPLAY ====*/
  lv_disp_drv_t disp_drv;
  lv_disp_drv_init(&disp_drv);
  disp_drv.hor_res = screenWidth;
  disp_drv.ver_res = screenHeight;
  disp_drv.flush_cb = my_disp_flush;
  disp_drv.buffer = &disp_buf;
  lv_disp_drv_register(&disp_drv);
  /* ==== Initialize the INPUT DEVICE DRIVER ====*/
  lv_indev_drv_t indev_drv;
  lv_indev_drv_init(&indev_drv);      /*Basic initialization*/
  indev_drv.type = LV_INDEV_TYPE_POINTER;   /*Touch pad is a pointer-like device*/
  indev_drv.read_cb = my_input_read;
  /*Register the driver in LVGL and save the created input device object*/
  lv_indev_drv_register(&indev_drv);
/* ==== EdgeLine Objects ==== */
    Screen1 = lv_obj_create(NULL, NULL);
    Sfondo1 = lv_obj_create(Screen1, NULL);
    lv_obj_set_click(Sfondo1, false);
    lv_obj_set_hidden(Sfondo1, false);
    lv_obj_clear_state(Sfondo1, LV_STATE_DISABLED);
    lv_obj_set_size(Sfondo1, 480, 320);  // force: 0
    lv_obj_align(Sfondo1, Screen1, LV_ALIGN_CENTER, 0, 0); // force: 480
    lv_obj_set_drag(Sfondo1, false);
    lv_obj_set_style_local_bg_color(Sfondo1, LV_BTN_PART_MAIN, LV_STATE_DEFAULT,lv_color_hex(48 * 256 * 256 + 169 * 256 + 192));
    lv_obj_set_style_local_bg_opa(Sfondo1, LV_BTN_PART_MAIN, LV_STATE_DEFAULT, 255);
    lv_obj_set_style_local_bg_grad_color(Sfondo1, LV_BTN_PART_MAIN, LV_STATE_DEFAULT,lv_color_hex(6 * 256 * 256 + 38 * 256 + 52));
    lv_obj_set_style_local_bg_main_stop(Sfondo1, LV_BTN_PART_MAIN, LV_STATE_DEFAULT, 0);
    lv_obj_set_style_local_bg_grad_stop(Sfondo1, LV_BTN_PART_MAIN, LV_STATE_DEFAULT, 320);
    lv_obj_set_style_local_radius(Sfondo1, LV_BTN_PART_MAIN, LV_STATE_DEFAULT, 60);
    lv_obj_set_style_local_bg_grad_dir(Sfondo1, LV_BTN_PART_MAIN, LV_STATE_DEFAULT, LV_GRAD_DIR_VER);
    lv_obj_set_style_local_border_color(Sfondo1, LV_BTN_PART_MAIN, LV_STATE_DEFAULT,lv_color_hex(0 * 256 * 256 + 0 * 256 + 0));
    lv_obj_set_style_local_border_opa(Sfondo1, LV_BTN_PART_MAIN, LV_STATE_DEFAULT, 255);
    lv_obj_set_style_local_border_width(Sfondo1, LV_BTN_PART_MAIN, LV_STATE_DEFAULT, 2);
    lv_obj_set_style_local_border_side(Sfondo1, LV_BTN_PART_MAIN, LV_STATE_DEFAULT, LV_BORDER_SIDE_FULL);
    lv_obj_set_style_local_shadow_color(Sfondo1, LV_BTN_PART_MAIN, LV_STATE_DEFAULT,lv_color_hex(0 * 256 * 256 + 0 * 256 + 0));
    lv_obj_set_style_local_shadow_opa(Sfondo1, LV_BTN_PART_MAIN, LV_STATE_DEFAULT, 255);
    lv_obj_set_style_local_shadow_width(Sfondo1, LV_BTN_PART_MAIN, LV_STATE_DEFAULT, 60);
    lv_obj_set_style_local_shadow_spread(Sfondo1, LV_BTN_PART_MAIN, LV_STATE_DEFAULT, 10);
    LabelWIFI = lv_label_create(Screen1, NULL);
    lv_label_set_long_mode(LabelWIFI, LV_LABEL_LONG_CROP);
    lv_label_set_align(LabelWIFI, LV_LABEL_ALIGN_CENTER);
    lv_label_set_text(LabelWIFI, "WIFI\n");
    lv_obj_set_size(LabelWIFI, 88, 40);  // force: -138
    lv_obj_set_click(LabelWIFI, true);
    lv_obj_set_hidden(LabelWIFI, false);
    lv_obj_clear_state(LabelWIFI, LV_STATE_DISABLED);
    lv_obj_set_drag(LabelWIFI, false);
    lv_obj_set_style_local_text_color(LabelWIFI, LV_BTN_PART_MAIN, LV_STATE_DEFAULT,lv_color_hex(252 * 256 * 256 + 252 * 256 + 252));
    lv_obj_set_style_local_text_opa(LabelWIFI, LV_BTN_PART_MAIN, LV_STATE_DEFAULT, 150);
    lv_obj_set_style_local_text_font(LabelWIFI, LV_BTN_PART_MAIN, LV_STATE_DEFAULT, LV_font_montserrat_20);
    lv_obj_set_style_local_bg_color(LabelWIFI, LV_BTN_PART_MAIN, LV_STATE_DEFAULT,lv_color_hex(45 * 256 * 256 + 160 * 256 + 183));
    lv_obj_set_style_local_bg_opa(LabelWIFI, LV_BTN_PART_MAIN, LV_STATE_DEFAULT, 255);
    lv_obj_set_style_local_bg_grad_color(LabelWIFI, LV_BTN_PART_MAIN, LV_STATE_DEFAULT,lv_color_hex(10 * 256 * 256 + 19 * 256 + 24));
    lv_obj_set_style_local_bg_main_stop(LabelWIFI, LV_BTN_PART_MAIN, LV_STATE_DEFAULT, 30);
    lv_obj_set_style_local_bg_grad_stop(LabelWIFI, LV_BTN_PART_MAIN, LV_STATE_DEFAULT, 128);
    lv_obj_set_style_local_radius(LabelWIFI, LV_BTN_PART_MAIN, LV_STATE_DEFAULT, 20);
    lv_obj_set_style_local_bg_grad_dir(LabelWIFI, LV_BTN_PART_MAIN, LV_STATE_DEFAULT, LV_GRAD_DIR_VER);
    lv_obj_set_style_local_border_color(LabelWIFI, LV_BTN_PART_MAIN, LV_STATE_DEFAULT,lv_color_hex(0 * 256 * 256 + 0 * 256 + 0));
    lv_obj_set_style_local_border_opa(LabelWIFI, LV_BTN_PART_MAIN, LV_STATE_DEFAULT, 255);
    lv_obj_set_style_local_border_width(LabelWIFI, LV_BTN_PART_MAIN, LV_STATE_DEFAULT, 1);
    lv_obj_set_style_local_border_side(LabelWIFI, LV_BTN_PART_MAIN, LV_STATE_DEFAULT, LV_BORDER_SIDE_FULL);
    lv_obj_set_style_local_shadow_color(LabelWIFI, LV_BTN_PART_MAIN, LV_STATE_DEFAULT,lv_color_hex(0 * 256 * 256 + 0 * 256 + 0));
    lv_obj_set_style_local_shadow_opa(LabelWIFI, LV_BTN_PART_MAIN, LV_STATE_DEFAULT, 200);
    lv_obj_set_style_local_shadow_width(LabelWIFI, LV_BTN_PART_MAIN, LV_STATE_DEFAULT, 40);
    lv_obj_set_style_local_shadow_spread(LabelWIFI, LV_BTN_PART_MAIN, LV_STATE_DEFAULT, 5);
    lv_obj_set_style_local_pad_left(LabelWIFI, LV_BTN_PART_MAIN, LV_STATE_DEFAULT, 10);
    lv_obj_set_style_local_pad_right(LabelWIFI, LV_BTN_PART_MAIN, LV_STATE_DEFAULT, 10);
    lv_obj_set_style_local_pad_top(LabelWIFI, LV_BTN_PART_MAIN, LV_STATE_DEFAULT, 10);
    lv_obj_set_style_local_pad_bottom(LabelWIFI, LV_BTN_PART_MAIN, LV_STATE_DEFAULT, 10);
    lv_obj_set_style_local_text_color(LabelWIFI, LV_BTN_PART_MAIN, LV_STATE_PRESSED,lv_color_hex(254 * 256 * 256 + 253 * 256 + 206));
    lv_obj_set_style_local_text_opa(LabelWIFI, LV_BTN_PART_MAIN, LV_STATE_PRESSED, 255);
    lv_obj_set_style_local_text_font(LabelWIFI, LV_BTN_PART_MAIN, LV_STATE_PRESSED, LV_font_montserrat_20);
    lv_obj_set_style_local_shadow_color(LabelWIFI, LV_BTN_PART_MAIN, LV_STATE_PRESSED,lv_color_hex(90 * 256 * 256 + 152 * 256 + 215));
    lv_obj_set_style_local_shadow_opa(LabelWIFI, LV_BTN_PART_MAIN, LV_STATE_PRESSED, 255);
    lv_obj_set_style_local_shadow_width(LabelWIFI, LV_BTN_PART_MAIN, LV_STATE_PRESSED, 40);
    lv_obj_set_style_local_shadow_spread(LabelWIFI, LV_BTN_PART_MAIN, LV_STATE_PRESSED, 6);
    lv_obj_set_style_local_text_color(LabelWIFI, LV_BTN_PART_MAIN, LV_STATE_DISABLED,lv_color_hex(0 * 256 * 256 + 0 * 256 + 0));
    lv_obj_set_style_local_text_opa(LabelWIFI, LV_BTN_PART_MAIN, LV_STATE_DISABLED, 255);
    lv_obj_align(LabelWIFI, Screen1, LV_ALIGN_CENTER, -138, 130); // force: 88
    LabelPREF = lv_label_create(Screen1, NULL);
    lv_label_set_long_mode(LabelPREF, LV_LABEL_LONG_CROP);
    lv_label_set_align(LabelPREF, LV_LABEL_ALIGN_CENTER);
    lv_label_set_text(LabelPREF, "PREF");
    lv_obj_set_size(LabelPREF, 88, 40);  // force: 138
    lv_obj_set_click(LabelPREF, true);
    lv_obj_set_hidden(LabelPREF, false);
    lv_obj_clear_state(LabelPREF, LV_STATE_DISABLED);
    lv_obj_set_drag(LabelPREF, false);
    lv_obj_set_style_local_text_color(LabelPREF, LV_BTN_PART_MAIN, LV_STATE_DEFAULT,lv_color_hex(255 * 256 * 256 + 255 * 256 + 255));
    lv_obj_set_style_local_text_opa(LabelPREF, LV_BTN_PART_MAIN, LV_STATE_DEFAULT, 150);
    lv_obj_set_style_local_text_font(LabelPREF, LV_BTN_PART_MAIN, LV_STATE_DEFAULT, LV_font_montserrat_20);
    lv_obj_set_style_local_bg_color(LabelPREF, LV_BTN_PART_MAIN, LV_STATE_DEFAULT,lv_color_hex(45 * 256 * 256 + 160 * 256 + 183));
    lv_obj_set_style_local_bg_opa(LabelPREF, LV_BTN_PART_MAIN, LV_STATE_DEFAULT, 255);
    lv_obj_set_style_local_bg_grad_color(LabelPREF, LV_BTN_PART_MAIN, LV_STATE_DEFAULT,lv_color_hex(10 * 256 * 256 + 19 * 256 + 24));
    lv_obj_set_style_local_bg_main_stop(LabelPREF, LV_BTN_PART_MAIN, LV_STATE_DEFAULT, 30);
    lv_obj_set_style_local_bg_grad_stop(LabelPREF, LV_BTN_PART_MAIN, LV_STATE_DEFAULT, 128);
    lv_obj_set_style_local_radius(LabelPREF, LV_BTN_PART_MAIN, LV_STATE_DEFAULT, 20);
    lv_obj_set_style_local_bg_grad_dir(LabelPREF, LV_BTN_PART_MAIN, LV_STATE_DEFAULT, LV_GRAD_DIR_VER);
    lv_obj_set_style_local_border_color(LabelPREF, LV_BTN_PART_MAIN, LV_STATE_DEFAULT,lv_color_hex(0 * 256 * 256 + 0 * 256 + 0));
    lv_obj_set_style_local_border_opa(LabelPREF, LV_BTN_PART_MAIN, LV_STATE_DEFAULT, 255);
    lv_obj_set_style_local_border_width(LabelPREF, LV_BTN_PART_MAIN, LV_STATE_DEFAULT, 1);
    lv_obj_set_style_local_border_side(LabelPREF, LV_BTN_PART_MAIN, LV_STATE_DEFAULT, LV_BORDER_SIDE_FULL);
    lv_obj_set_style_local_shadow_color(LabelPREF, LV_BTN_PART_MAIN, LV_STATE_DEFAULT,lv_color_hex(0 * 256 * 256 + 0 * 256 + 0));
    lv_obj_set_style_local_shadow_opa(LabelPREF, LV_BTN_PART_MAIN, LV_STATE_DEFAULT, 200);
    lv_obj_set_style_local_shadow_width(LabelPREF, LV_BTN_PART_MAIN, LV_STATE_DEFAULT, 40);
    lv_obj_set_style_local_shadow_spread(LabelPREF, LV_BTN_PART_MAIN, LV_STATE_DEFAULT, 5);
    lv_obj_set_style_local_pad_left(LabelPREF, LV_BTN_PART_MAIN, LV_STATE_DEFAULT, 10);
    lv_obj_set_style_local_pad_right(LabelPREF, LV_BTN_PART_MAIN, LV_STATE_DEFAULT, 10);
    lv_obj_set_style_local_pad_top(LabelPREF, LV_BTN_PART_MAIN, LV_STATE_DEFAULT, 10);
    lv_obj_set_style_local_pad_bottom(LabelPREF, LV_BTN_PART_MAIN, LV_STATE_DEFAULT, 10);
    lv_obj_set_style_local_text_color(LabelPREF, LV_BTN_PART_MAIN, LV_STATE_PRESSED,lv_color_hex(254 * 256 * 256 + 253 * 256 + 206));
    lv_obj_set_style_local_text_opa(LabelPREF, LV_BTN_PART_MAIN, LV_STATE_PRESSED, 255);
    lv_obj_set_style_local_shadow_color(LabelPREF, LV_BTN_PART_MAIN, LV_STATE_PRESSED,lv_color_hex(90 * 256 * 256 + 152 * 256 + 215));
    lv_obj_set_style_local_shadow_opa(LabelPREF, LV_BTN_PART_MAIN, LV_STATE_PRESSED, 255);
    lv_obj_set_style_local_shadow_width(LabelPREF, LV_BTN_PART_MAIN, LV_STATE_PRESSED, 40);
    lv_obj_set_style_local_shadow_spread(LabelPREF, LV_BTN_PART_MAIN, LV_STATE_PRESSED, 6);
    lv_obj_align(LabelPREF, Screen1, LV_ALIGN_CENTER, 138, 130); // force: 88
    LabelToast = lv_label_create(Screen1, NULL);
    lv_label_set_long_mode(LabelToast, LV_LABEL_LONG_BREAK);
    lv_label_set_align(LabelToast, LV_LABEL_ALIGN_CENTER);
    lv_label_set_text(LabelToast, "Info Text  click for close");
    lv_obj_set_size(LabelToast, 260, 22);  // force: 0
    lv_obj_set_click(LabelToast, true);
    lv_obj_set_hidden(LabelToast, false);
    lv_obj_clear_state(LabelToast, LV_STATE_DISABLED);
    lv_obj_set_drag(LabelToast, false);
    lv_obj_set_style_local_text_color(LabelToast, LV_BTN_PART_MAIN, LV_STATE_DEFAULT,lv_color_hex(255 * 256 * 256 + 255 * 256 + 255));
    lv_obj_set_style_local_text_opa(LabelToast, LV_BTN_PART_MAIN, LV_STATE_DEFAULT, 255);
    lv_obj_set_style_local_text_font(LabelToast, LV_BTN_PART_MAIN, LV_STATE_DEFAULT, LV_font_montserrat_14);
    lv_obj_set_style_local_bg_color(LabelToast, LV_BTN_PART_MAIN, LV_STATE_DEFAULT,lv_color_hex(103 * 256 * 256 + 139 * 256 + 156));
    lv_obj_set_style_local_bg_opa(LabelToast, LV_BTN_PART_MAIN, LV_STATE_DEFAULT, 255);
    lv_obj_set_style_local_bg_grad_color(LabelToast, LV_BTN_PART_MAIN, LV_STATE_DEFAULT,lv_color_hex(21 * 256 * 256 + 32 * 256 + 38));
    lv_obj_set_style_local_bg_main_stop(LabelToast, LV_BTN_PART_MAIN, LV_STATE_DEFAULT, 0);
    lv_obj_set_style_local_bg_grad_stop(LabelToast, LV_BTN_PART_MAIN, LV_STATE_DEFAULT, 255);
    lv_obj_set_style_local_radius(LabelToast, LV_BTN_PART_MAIN, LV_STATE_DEFAULT, 10);
    lv_obj_set_style_local_bg_grad_dir(LabelToast, LV_BTN_PART_MAIN, LV_STATE_DEFAULT, LV_GRAD_DIR_VER);
    lv_obj_set_style_local_shadow_color(LabelToast, LV_BTN_PART_MAIN, LV_STATE_DEFAULT,lv_color_hex(0 * 256 * 256 + 0 * 256 + 0));
    lv_obj_set_style_local_shadow_opa(LabelToast, LV_BTN_PART_MAIN, LV_STATE_DEFAULT, 200);
    lv_obj_set_style_local_shadow_width(LabelToast, LV_BTN_PART_MAIN, LV_STATE_DEFAULT, 30);
    lv_obj_set_style_local_shadow_spread(LabelToast, LV_BTN_PART_MAIN, LV_STATE_DEFAULT, 5);
    lv_obj_set_style_local_pad_left(LabelToast, LV_BTN_PART_MAIN, LV_STATE_DEFAULT, 6);
    lv_obj_set_style_local_pad_right(LabelToast, LV_BTN_PART_MAIN, LV_STATE_DEFAULT, 6);
    lv_obj_set_style_local_pad_top(LabelToast, LV_BTN_PART_MAIN, LV_STATE_DEFAULT, 3);
    lv_obj_set_style_local_pad_bottom(LabelToast, LV_BTN_PART_MAIN, LV_STATE_DEFAULT, 3);
    lv_obj_align(LabelToast, Screen1, LV_ALIGN_IN_TOP_MID, 0, 10); // force: 260
    RollerSSID = lv_roller_create(Screen1, NULL);
    lv_roller_set_options(RollerSSID, "SSID\naaaaaaaaa\nbbbbb", LV_ROLLER_MODE_NORMAL);
    lv_roller_set_anim_time(RollerSSID, 100);
    lv_roller_set_align(RollerSSID, LV_LABEL_ALIGN_CENTER);
    lv_obj_set_click(RollerSSID, true);
    lv_obj_set_hidden(RollerSSID, true);
    lv_obj_clear_state(RollerSSID, LV_STATE_DISABLED);
    lv_obj_set_drag(RollerSSID, false);
    lv_obj_align(RollerSSID, Screen1, LV_ALIGN_CENTER, 0, 0);
    lv_obj_set_event_cb(RollerSSID, RollerSSID_eventhandler);
    lv_roller_set_visible_row_count(RollerSSID, 3);
    lv_obj_set_style_local_text_color(RollerSSID, LV_ROLLER_PART_BG, LV_STATE_DEFAULT,lv_color_hex(213 * 256 * 256 + 250 * 256 + 254));
    lv_obj_set_style_local_text_opa(RollerSSID, LV_ROLLER_PART_BG, LV_STATE_DEFAULT, 150);
    lv_obj_set_style_local_text_letter_space(RollerSSID, LV_ROLLER_PART_BG, LV_STATE_DEFAULT, 0);
    lv_obj_set_style_local_text_line_space(RollerSSID, LV_ROLLER_PART_BG, LV_STATE_DEFAULT, 10);
    lv_obj_set_style_local_text_font(RollerSSID, LV_ROLLER_PART_BG, LV_STATE_DEFAULT, LV_font_montserrat_12);
    lv_obj_set_style_local_bg_color(RollerSSID, LV_ROLLER_PART_BG, LV_STATE_DEFAULT,lv_color_hex(100 * 256 * 256 + 163 * 256 + 192));
    lv_obj_set_style_local_bg_opa(RollerSSID, LV_ROLLER_PART_BG, LV_STATE_DEFAULT, 255);
    lv_obj_set_style_local_bg_grad_color(RollerSSID, LV_ROLLER_PART_BG, LV_STATE_DEFAULT,lv_color_hex(9 * 256 * 256 + 22 * 256 + 29));
    lv_obj_set_style_local_bg_main_stop(RollerSSID, LV_ROLLER_PART_BG, LV_STATE_DEFAULT, 0);
    lv_obj_set_style_local_bg_grad_stop(RollerSSID, LV_ROLLER_PART_BG, LV_STATE_DEFAULT, 600);
    lv_obj_set_style_local_radius(RollerSSID, LV_ROLLER_PART_BG, LV_STATE_DEFAULT, 16);
    lv_obj_set_style_local_bg_grad_dir(RollerSSID, LV_ROLLER_PART_BG, LV_STATE_DEFAULT, LV_GRAD_DIR_VER);
    lv_obj_set_style_local_border_color(RollerSSID, LV_ROLLER_PART_BG, LV_STATE_DEFAULT,lv_color_hex(0 * 256 * 256 + 0 * 256 + 0));
    lv_obj_set_style_local_border_opa(RollerSSID, LV_ROLLER_PART_BG, LV_STATE_DEFAULT, 255);
    lv_obj_set_style_local_border_width(RollerSSID, LV_ROLLER_PART_BG, LV_STATE_DEFAULT, 1);
    lv_obj_set_style_local_border_side(RollerSSID, LV_ROLLER_PART_BG, LV_STATE_DEFAULT, LV_BORDER_SIDE_FULL);
    lv_obj_set_style_local_shadow_color(RollerSSID, LV_ROLLER_PART_BG, LV_STATE_DEFAULT,lv_color_hex(0 * 256 * 256 + 0 * 256 + 0));
    lv_obj_set_style_local_shadow_opa(RollerSSID, LV_ROLLER_PART_BG, LV_STATE_DEFAULT, 200);
    lv_obj_set_style_local_shadow_width(RollerSSID, LV_ROLLER_PART_BG, LV_STATE_DEFAULT, 30);
    lv_obj_set_style_local_shadow_spread(RollerSSID, LV_ROLLER_PART_BG, LV_STATE_DEFAULT, 5);
    lv_obj_set_style_local_text_color(RollerSSID, LV_ROLLER_PART_BG, LV_STATE_CHECKED,lv_color_hex(213 * 256 * 256 + 250 * 256 + 254));
    lv_obj_set_style_local_text_opa(RollerSSID, LV_ROLLER_PART_BG, LV_STATE_CHECKED, 255);
    lv_obj_set_style_local_text_font(RollerSSID, LV_ROLLER_PART_BG, LV_STATE_CHECKED, LV_font_montserrat_14);
    lv_obj_set_style_local_text_color(RollerSSID, LV_ROLLER_PART_BG, LV_STATE_PRESSED,lv_color_hex(213 * 256 * 256 + 250 * 256 + 254));
    lv_obj_set_style_local_text_opa(RollerSSID, LV_ROLLER_PART_BG, LV_STATE_PRESSED, 255);
    lv_obj_set_style_local_text_font(RollerSSID, LV_ROLLER_PART_BG, LV_STATE_PRESSED, LV_font_montserrat_12);
    lv_obj_set_style_local_shadow_color(RollerSSID, LV_ROLLER_PART_BG, LV_STATE_PRESSED,lv_color_hex(90 * 256 * 256 + 152 * 256 + 215));
    lv_obj_set_style_local_shadow_opa(RollerSSID, LV_ROLLER_PART_BG, LV_STATE_PRESSED, 200);
    lv_obj_set_style_local_shadow_width(RollerSSID, LV_ROLLER_PART_BG, LV_STATE_PRESSED, 40);
    lv_obj_set_style_local_shadow_spread(RollerSSID, LV_ROLLER_PART_BG, LV_STATE_PRESSED, 8);
    lv_obj_set_style_local_text_color(RollerSSID, LV_ROLLER_PART_BG, LV_STATE_CHECKED | LV_STATE_PRESSED,lv_color_hex(213 * 256 * 256 + 250 * 256 + 254));
    lv_obj_set_style_local_text_opa(RollerSSID, LV_ROLLER_PART_BG, LV_STATE_CHECKED | LV_STATE_PRESSED, 255);
    lv_obj_set_style_local_text_font(RollerSSID, LV_ROLLER_PART_BG, LV_STATE_CHECKED | LV_STATE_PRESSED,LV_font_montserrat_12);
    lv_obj_set_style_local_text_color(RollerSSID, LV_ROLLER_PART_SELECTED, LV_STATE_DEFAULT,lv_color_hex(213 * 256 * 256 + 250 * 256 + 254));
    lv_obj_set_style_local_text_opa(RollerSSID, LV_ROLLER_PART_SELECTED, LV_STATE_DEFAULT, 255);
    lv_obj_set_style_local_text_letter_space(RollerSSID, LV_ROLLER_PART_SELECTED, LV_STATE_DEFAULT, 0);
    lv_obj_set_style_local_text_line_space(RollerSSID, LV_ROLLER_PART_SELECTED, LV_STATE_DEFAULT, 0);
    lv_obj_set_style_local_text_font(RollerSSID, LV_ROLLER_PART_SELECTED, LV_STATE_DEFAULT, LV_font_montserrat_14);
    lv_obj_set_style_local_bg_color(RollerSSID, LV_ROLLER_PART_SELECTED, LV_STATE_DEFAULT,lv_color_hex(105 * 256 * 256 + 143 * 256 + 164));
    lv_obj_set_style_local_bg_opa(RollerSSID, LV_ROLLER_PART_SELECTED, LV_STATE_DEFAULT, 255);
    lv_obj_set_style_local_bg_grad_color(RollerSSID, LV_ROLLER_PART_SELECTED, LV_STATE_DEFAULT,lv_color_hex(23 * 256 * 256 + 46 * 256 + 59));
    lv_obj_set_style_local_bg_main_stop(RollerSSID, LV_ROLLER_PART_SELECTED, LV_STATE_DEFAULT, 0);
    lv_obj_set_style_local_bg_grad_stop(RollerSSID, LV_ROLLER_PART_SELECTED, LV_STATE_DEFAULT, 128);
    lv_obj_set_style_local_radius(RollerSSID, LV_ROLLER_PART_SELECTED, LV_STATE_DEFAULT, 8);
    lv_obj_set_style_local_bg_grad_dir(RollerSSID, LV_ROLLER_PART_SELECTED, LV_STATE_DEFAULT, LV_GRAD_DIR_VER);
    lv_obj_set_style_local_shadow_color(RollerSSID, LV_ROLLER_PART_SELECTED, LV_STATE_DEFAULT,lv_color_hex(3 * 256 * 256 + 17 * 256 + 24));
    lv_obj_set_style_local_shadow_opa(RollerSSID, LV_ROLLER_PART_SELECTED, LV_STATE_DEFAULT, 255);
    lv_obj_set_style_local_shadow_width(RollerSSID, LV_ROLLER_PART_SELECTED, LV_STATE_DEFAULT, 60);
    lv_obj_set_style_local_shadow_spread(RollerSSID, LV_ROLLER_PART_SELECTED, LV_STATE_DEFAULT, 8);
    lv_obj_set_style_local_text_color(RollerSSID, LV_ROLLER_PART_SELECTED, LV_STATE_CHECKED,lv_color_hex(213 * 256 * 256 + 250 * 256 + 254));
    lv_obj_set_style_local_text_opa(RollerSSID, LV_ROLLER_PART_SELECTED, LV_STATE_CHECKED, 255);
    lv_obj_set_style_local_text_color(RollerSSID, LV_ROLLER_PART_SELECTED, LV_STATE_PRESSED,lv_color_hex(213 * 256 * 256 + 250 * 256 + 254));
    lv_obj_set_style_local_text_opa(RollerSSID, LV_ROLLER_PART_SELECTED, LV_STATE_PRESSED, 255);
    lv_obj_set_style_local_text_font(RollerSSID, LV_ROLLER_PART_SELECTED, LV_STATE_PRESSED, LV_font_montserrat_12);
    lv_obj_set_style_local_text_color(RollerSSID, LV_ROLLER_PART_SELECTED, LV_STATE_CHECKED | LV_STATE_PRESSED,lv_color_hex(213 * 256 * 256 + 250 * 256 + 254));
    lv_obj_set_style_local_text_opa(RollerSSID, LV_ROLLER_PART_SELECTED, LV_STATE_CHECKED | LV_STATE_PRESSED, 255);
    lv_obj_set_style_local_text_font(RollerSSID, LV_ROLLER_PART_SELECTED, LV_STATE_CHECKED | LV_STATE_PRESSED,LV_font_montserrat_12);
    LabelSSID = lv_label_create(Screen1, NULL);
    lv_label_set_long_mode(LabelSSID, LV_LABEL_LONG_EXPAND);
    lv_label_set_align(LabelSSID, LV_LABEL_ALIGN_CENTER);
    lv_label_set_text(LabelSSID, "SSID");
    lv_obj_set_size(LabelSSID, 58, 38);  // force: -138
    lv_obj_set_click(LabelSSID, true);
    lv_obj_set_hidden(LabelSSID, true);
    lv_obj_clear_state(LabelSSID, LV_STATE_DISABLED);
    lv_obj_set_drag(LabelSSID, false);
    lv_obj_set_style_local_text_color(LabelSSID, LV_BTN_PART_MAIN, LV_STATE_DEFAULT,lv_color_hex(213 * 256 * 256 + 250 * 256 + 254));
    lv_obj_set_style_local_text_opa(LabelSSID, LV_BTN_PART_MAIN, LV_STATE_DEFAULT, 255);
    lv_obj_set_style_local_text_font(LabelSSID, LV_BTN_PART_MAIN, LV_STATE_DEFAULT, LV_font_montserrat_16);
    lv_obj_set_style_local_bg_color(LabelSSID, LV_BTN_PART_MAIN, LV_STATE_DEFAULT,lv_color_hex(45 * 256 * 256 + 160 * 256 + 183));
    lv_obj_set_style_local_bg_opa(LabelSSID, LV_BTN_PART_MAIN, LV_STATE_DEFAULT, 255);
    lv_obj_set_style_local_bg_grad_color(LabelSSID, LV_BTN_PART_MAIN, LV_STATE_DEFAULT,lv_color_hex(10 * 256 * 256 + 19 * 256 + 24));
    lv_obj_set_style_local_bg_main_stop(LabelSSID, LV_BTN_PART_MAIN, LV_STATE_DEFAULT, 0);
    lv_obj_set_style_local_bg_grad_stop(LabelSSID, LV_BTN_PART_MAIN, LV_STATE_DEFAULT, 128);
    lv_obj_set_style_local_radius(LabelSSID, LV_BTN_PART_MAIN, LV_STATE_DEFAULT, 20);
    lv_obj_set_style_local_bg_grad_dir(LabelSSID, LV_BTN_PART_MAIN, LV_STATE_DEFAULT, LV_GRAD_DIR_VER);
    lv_obj_set_style_local_border_color(LabelSSID, LV_BTN_PART_MAIN, LV_STATE_DEFAULT,lv_color_hex(0 * 256 * 256 + 0 * 256 + 0));
    lv_obj_set_style_local_border_opa(LabelSSID, LV_BTN_PART_MAIN, LV_STATE_DEFAULT, 255);
    lv_obj_set_style_local_border_width(LabelSSID, LV_BTN_PART_MAIN, LV_STATE_DEFAULT, 1);
    lv_obj_set_style_local_border_side(LabelSSID, LV_BTN_PART_MAIN, LV_STATE_DEFAULT, LV_BORDER_SIDE_FULL);
    lv_obj_set_style_local_shadow_color(LabelSSID, LV_BTN_PART_MAIN, LV_STATE_DEFAULT,lv_color_hex(0 * 256 * 256 + 0 * 256 + 0));
    lv_obj_set_style_local_shadow_opa(LabelSSID, LV_BTN_PART_MAIN, LV_STATE_DEFAULT, 200);
    lv_obj_set_style_local_shadow_width(LabelSSID, LV_BTN_PART_MAIN, LV_STATE_DEFAULT, 40);
    lv_obj_set_style_local_shadow_spread(LabelSSID, LV_BTN_PART_MAIN, LV_STATE_DEFAULT, 5);
    lv_obj_set_style_local_pad_left(LabelSSID, LV_BTN_PART_MAIN, LV_STATE_DEFAULT, 10);
    lv_obj_set_style_local_pad_right(LabelSSID, LV_BTN_PART_MAIN, LV_STATE_DEFAULT, 10);
    lv_obj_set_style_local_pad_top(LabelSSID, LV_BTN_PART_MAIN, LV_STATE_DEFAULT, 10);
    lv_obj_set_style_local_pad_bottom(LabelSSID, LV_BTN_PART_MAIN, LV_STATE_DEFAULT, 10);
    lv_obj_set_style_local_text_color(LabelSSID, LV_BTN_PART_MAIN, LV_STATE_PRESSED,lv_color_hex(167 * 256 * 256 + 167 * 256 + 255));
    lv_obj_set_style_local_text_opa(LabelSSID, LV_BTN_PART_MAIN, LV_STATE_PRESSED, 255);
    lv_obj_set_style_local_text_font(LabelSSID, LV_BTN_PART_MAIN, LV_STATE_PRESSED, LV_font_montserrat_12);
    lv_obj_set_style_local_shadow_color(LabelSSID, LV_BTN_PART_MAIN, LV_STATE_PRESSED,lv_color_hex(90 * 256 * 256 + 152 * 256 + 215));
    lv_obj_set_style_local_shadow_opa(LabelSSID, LV_BTN_PART_MAIN, LV_STATE_PRESSED, 255);
    lv_obj_set_style_local_shadow_width(LabelSSID, LV_BTN_PART_MAIN, LV_STATE_PRESSED, 40);
    lv_obj_set_style_local_shadow_spread(LabelSSID, LV_BTN_PART_MAIN, LV_STATE_PRESSED, 8);
    lv_obj_align(LabelSSID, Screen1, LV_ALIGN_CENTER, -138, -80); // force: 58
    LabelPASSW = lv_label_create(Screen1, NULL);
    lv_label_set_long_mode(LabelPASSW, LV_LABEL_LONG_EXPAND);
    lv_label_set_align(LabelPASSW, LV_LABEL_ALIGN_CENTER);
    lv_label_set_text(LabelPASSW, "PASSW");
    lv_obj_set_size(LabelPASSW, 81, 38);  // force: -138
    lv_obj_set_click(LabelPASSW, true);
    lv_obj_set_hidden(LabelPASSW, true);
    lv_obj_clear_state(LabelPASSW, LV_STATE_DISABLED);
    lv_obj_set_drag(LabelPASSW, false);
    lv_obj_set_style_local_text_color(LabelPASSW, LV_BTN_PART_MAIN, LV_STATE_DEFAULT,lv_color_hex(213 * 256 * 256 + 250 * 256 + 254));
    lv_obj_set_style_local_text_opa(LabelPASSW, LV_BTN_PART_MAIN, LV_STATE_DEFAULT, 255);
    lv_obj_set_style_local_text_font(LabelPASSW, LV_BTN_PART_MAIN, LV_STATE_DEFAULT, LV_font_montserrat_16);
    lv_obj_set_style_local_bg_color(LabelPASSW, LV_BTN_PART_MAIN, LV_STATE_DEFAULT,lv_color_hex(45 * 256 * 256 + 160 * 256 + 183));
    lv_obj_set_style_local_bg_opa(LabelPASSW, LV_BTN_PART_MAIN, LV_STATE_DEFAULT, 255);
    lv_obj_set_style_local_bg_grad_color(LabelPASSW, LV_BTN_PART_MAIN, LV_STATE_DEFAULT,lv_color_hex(10 * 256 * 256 + 19 * 256 + 24));
    lv_obj_set_style_local_bg_main_stop(LabelPASSW, LV_BTN_PART_MAIN, LV_STATE_DEFAULT, 30);
    lv_obj_set_style_local_bg_grad_stop(LabelPASSW, LV_BTN_PART_MAIN, LV_STATE_DEFAULT, 128);
    lv_obj_set_style_local_radius(LabelPASSW, LV_BTN_PART_MAIN, LV_STATE_DEFAULT, 20);
    lv_obj_set_style_local_bg_grad_dir(LabelPASSW, LV_BTN_PART_MAIN, LV_STATE_DEFAULT, LV_GRAD_DIR_VER);
    lv_obj_set_style_local_border_color(LabelPASSW, LV_BTN_PART_MAIN, LV_STATE_DEFAULT,lv_color_hex(0 * 256 * 256 + 0 * 256 + 0));
    lv_obj_set_style_local_border_opa(LabelPASSW, LV_BTN_PART_MAIN, LV_STATE_DEFAULT, 255);
    lv_obj_set_style_local_border_width(LabelPASSW, LV_BTN_PART_MAIN, LV_STATE_DEFAULT, 1);
    lv_obj_set_style_local_border_side(LabelPASSW, LV_BTN_PART_MAIN, LV_STATE_DEFAULT, LV_BORDER_SIDE_FULL);
    lv_obj_set_style_local_shadow_color(LabelPASSW, LV_BTN_PART_MAIN, LV_STATE_DEFAULT,lv_color_hex(0 * 256 * 256 + 0 * 256 + 0));
    lv_obj_set_style_local_shadow_opa(LabelPASSW, LV_BTN_PART_MAIN, LV_STATE_DEFAULT, 200);
    lv_obj_set_style_local_shadow_width(LabelPASSW, LV_BTN_PART_MAIN, LV_STATE_DEFAULT, 40);
    lv_obj_set_style_local_shadow_spread(LabelPASSW, LV_BTN_PART_MAIN, LV_STATE_DEFAULT, 5);
    lv_obj_set_style_local_pad_left(LabelPASSW, LV_BTN_PART_MAIN, LV_STATE_DEFAULT, 10);
    lv_obj_set_style_local_pad_right(LabelPASSW, LV_BTN_PART_MAIN, LV_STATE_DEFAULT, 10);
    lv_obj_set_style_local_pad_top(LabelPASSW, LV_BTN_PART_MAIN, LV_STATE_DEFAULT, 10);
    lv_obj_set_style_local_pad_bottom(LabelPASSW, LV_BTN_PART_MAIN, LV_STATE_DEFAULT, 10);
    lv_obj_set_style_local_text_color(LabelPASSW, LV_BTN_PART_MAIN, LV_STATE_PRESSED,lv_color_hex(167 * 256 * 256 + 167 * 256 + 255));
    lv_obj_set_style_local_text_opa(LabelPASSW, LV_BTN_PART_MAIN, LV_STATE_PRESSED, 255);
    lv_obj_set_style_local_text_font(LabelPASSW, LV_BTN_PART_MAIN, LV_STATE_PRESSED, LV_font_montserrat_12);
    lv_obj_set_style_local_shadow_color(LabelPASSW, LV_BTN_PART_MAIN, LV_STATE_PRESSED,lv_color_hex(90 * 256 * 256 + 152 * 256 + 215));
    lv_obj_set_style_local_shadow_opa(LabelPASSW, LV_BTN_PART_MAIN, LV_STATE_PRESSED, 255);
    lv_obj_set_style_local_shadow_width(LabelPASSW, LV_BTN_PART_MAIN, LV_STATE_PRESSED, 40);
    lv_obj_set_style_local_shadow_spread(LabelPASSW, LV_BTN_PART_MAIN, LV_STATE_PRESSED, 8);
    lv_obj_align(LabelPASSW, Screen1, LV_ALIGN_CENTER, -138, -20); // force: 81
    ListPref = lv_obj_create(Screen1, NULL);
    lv_obj_set_click(ListPref, true);
    lv_obj_set_hidden(ListPref, false);
    lv_obj_clear_state(ListPref, LV_STATE_DISABLED);
    lv_obj_set_size(ListPref, 211, 108);  // force: 0
    lv_obj_align(ListPref, Screen1, LV_ALIGN_IN_TOP_MID, 0, 40); // force: 211
    lv_obj_set_drag(ListPref, false);
    lv_obj_set_event_cb(ListPref, ListPref_eventhandler);
    lv_obj_set_style_local_bg_color(ListPref, LV_BTN_PART_MAIN, LV_STATE_DEFAULT,lv_color_hex(37 * 256 * 256 + 130 * 256 + 148));
    lv_obj_set_style_local_bg_opa(ListPref, LV_BTN_PART_MAIN, LV_STATE_DEFAULT, 255);
    lv_obj_set_style_local_bg_grad_color(ListPref, LV_BTN_PART_MAIN, LV_STATE_DEFAULT,lv_color_hex(9 * 256 * 256 + 33 * 256 + 38));
    lv_obj_set_style_local_bg_main_stop(ListPref, LV_BTN_PART_MAIN, LV_STATE_DEFAULT, 0);
    lv_obj_set_style_local_bg_grad_stop(ListPref, LV_BTN_PART_MAIN, LV_STATE_DEFAULT, 200);
    lv_obj_set_style_local_radius(ListPref, LV_BTN_PART_MAIN, LV_STATE_DEFAULT, 10);
    lv_obj_set_style_local_bg_grad_dir(ListPref, LV_BTN_PART_MAIN, LV_STATE_DEFAULT, LV_GRAD_DIR_VER);
    ListPref.set_style_local_clip_corner(lv.btn.PART.MAIN, lv.STATE.DEFAULT, True)
    lv_obj_set_style_local_border_color(ListPref, LV_BTN_PART_MAIN, LV_STATE_DEFAULT,lv_color_hex(0 * 256 * 256 + 0 * 256 + 0));
    lv_obj_set_style_local_border_opa(ListPref, LV_BTN_PART_MAIN, LV_STATE_DEFAULT, 255);
    lv_obj_set_style_local_border_width(ListPref, LV_BTN_PART_MAIN, LV_STATE_DEFAULT, 1);
    lv_obj_set_style_local_border_side(ListPref, LV_BTN_PART_MAIN, LV_STATE_DEFAULT, LV_BORDER_SIDE_FULL);
    lv_obj_set_style_local_shadow_color(ListPref, LV_BTN_PART_MAIN, LV_STATE_DEFAULT,lv_color_hex(0 * 256 * 256 + 0 * 256 + 0));
    lv_obj_set_style_local_shadow_opa(ListPref, LV_BTN_PART_MAIN, LV_STATE_DEFAULT, 255);
    lv_obj_set_style_local_shadow_width(ListPref, LV_BTN_PART_MAIN, LV_STATE_DEFAULT, 30);
    lv_obj_set_style_local_shadow_spread(ListPref, LV_BTN_PART_MAIN, LV_STATE_DEFAULT, 2);
    ImgButton1 = lv_imgbtn_create(Screen1, NULL);
    lv_obj_set_click(ImgButton1, true);
    lv_obj_set_hidden(ImgButton1, false);
    lv_obj_clear_state(ImgButton1, LV_STATE_DISABLED);
    lv_obj_align(ImgButton1, Screen1, LV_ALIGN_CENTER, 3, 99); // force: 130
    lv_obj_set_drag(ImgButton1, false);
    lv_obj_set_event_cb(ImgButton1, ImgButton1_eventhandler);
/* ---- END of EdgeLine Objects ---- */
/* ======      START LOOP       START LOOP      ======== */
void loop() {
  lv_task_handler();
  delay(1);
}/* ----------- END LOOP     END LOOP     END LOOP  ------------*/

/* ==== PUT YOURS  ROUTINES HERE ==== */